KComboBox class Reference (kdeui Library)

| # kdeui Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KComboBox Class Reference

A combined button, line-edit and a popup list widget. An enhanced combo box. More...

`#include <kcombobox.h>`

Inheritance diagram for KComboBox:

[legend]
Collaboration diagram for KComboBox:

[legend]
List of all members.

## Public Slots
void | rotateText (KCompletionBase::KeyBindingType)
| Iterates through all possible matches of the completed text or the history list.
virtual void | setCompletedText (const QString &)
| Sets the completed text in the line-edit appropriately.
void | setCompletedItems (const QStringList &items)
| Sets `items` into the completion-box if completionMode() is CompletionPopup.
void | setCurrentItem (const QString &item, bool insert=false, int index=-1)
| Selects the first item that matches `item`.
void | setCurrentItem (int index)
## Signals
void | returnPressed ()
| Emitted when the user presses the Enter key.
void | returnPressed (const QString &)
| Emitted when the user presses the Enter key.
void | completion (const QString &)
| This signal is emitted when the completion key is pressed.
void | substringCompletion (const QString &)
| Emitted when the shortcut for substring completion is pressed.
void | textRotation (KCompletionBase::KeyBindingType)
| Emitted when the text rotation key-bindings are pressed.
void | completionModeChanged (KGlobalSettings::Completion)
| Emitted when the user changed the completion mode by using the popupmenu.
void | aboutToShowContextMenu (QPopupMenu *)
| Emitted before the context menu is displayed.
## Public Member Functions
| KComboBox (QWidget *parent=0, const char *name=0)
| Constructs a read-only or rather select-only combo box with a parent object and a name.
| KComboBox (bool rw, QWidget *parent=0, const char *name=0)
| Constructs a "read-write" or "read-only" combo box depending on the value of the first argument( `rw` ) with a parent, a name.
virtual | ~KComboBox ()
| Destructor.
void | setEditURL (const KURL &url)
| Sets `url` into the edit field of the combobox.
void | insertURL (const KURL &url, int index=-1)
| Inserts `url` at position `index` into the combobox.
void | insertURL (const QPixmap &pixmap, const KURL &url, int index=-1)
| Inserts `url` with the pixmap &p pixmap at position `index` into the combobox.
void | changeURL (const KURL &url, int index)
| Replaces the item at position `index` with `url`.
void | changeURL (const QPixmap &pixmap, const KURL &url, int index)
| Replaces the item at position `index` with `url` and pixmap `pixmap`.
int | cursorPosition () const
| Returns the current cursor position.
virtual void | setAutoCompletion (bool autocomplete)
| Re-implemented from QComboBox.
bool | autoCompletion () const
| Re-implemented from QComboBox.
virtual void | setContextMenuEnabled (bool showMenu)
| Enables or disable the popup (context) menu.
bool | isContextMenuEnabled () const
| Returns `true` when the context menu is enabled.
void | setURLDropsEnabled (bool enable)
| Enables/Disables handling of URL drops.
bool | isURLDropsEnabled () const
| Returns `true` when decoded URL drops are enabled.
bool | contains (const QString &text) const
| Convenience method which iterates over all items and checks if any of them is equal to `text`.
void | setTrapReturnKey (bool trap)
| By default, KComboBox recognizes Key_Return and Key_Enter and emits the returnPressed() signals, but it also lets the event pass, for example causing a dialog's default-button to be called.
bool | trapReturnKey () const
virtual bool | eventFilter (QObject *, QEvent *)
| Re-implemented for internal reasons.
KCompletionBox * | completionBox (bool create=true)
virtual void | setLineEdit (QLineEdit *)
## Protected Slots
virtual void | itemSelected (QListBoxItem *)
| This class or method is obsolete, it is provided for compatibility only..
virtual void | makeCompletion (const QString &)
| Completes text according to the completion mode.
## Protected Member Functions
virtual void | setCompletedText (const QString &, bool)
virtual void | create (WId=0, bool initializeWindow=true, bool destroyOldWindow=true)
| Reimplemented for internal reasons, the API is not affected.
virtual void | wheelEvent (QWheelEvent *ev)
virtual void | virtual_hook (int id, void *data)

## Detailed Description

A combined button, line-edit and a popup list widget. An enhanced combo box.

Detail

This widget inherits from QComboBox and implements the following additional functionalities: a completion object that provides both automatic and manual text completion as well as text rotation features, configurable key-bindings to activate these features, and a popup-menu item that can be used to allow the user to change the text completion mode on the fly.

To support these new features KComboBox emits a few additional signals such as completion( const QString& ) and textRotation( KeyBindgingType ). The completion signal can be connected to a slot that will assist the user in filling out the remaining text while the rotation signal can be used to traverse through all possible matches whenever text completion results in multiple matches. Additionally, a returnPressed() and a returnPressed( const QString& ) signals are emitted when the user presses the Enter/Return key.

KCombobox by default creates a completion object when you invoke the completionObject( bool ) member function for the first time or explicitly use setCompletionObject( KCompletion*, bool ) to assign your own completion object. Additionally, to make this widget more functional, KComboBox will by default handle text rotation and completion events internally whenever a completion object is created through either one of the methods mentioned above. If you do not need this functionality, simply use KCompletionBase::setHandleSignals(bool) or alternatively set the boolean parameter in the `setCompletionObject` call to FALSE.

The default key-bindings for completion and rotation is determined from the global settings in KStdAccel. These values, however, can be overriden locally by invoking KCompletionBase::setKeyBinding(). The values can easily be reverted back to the default setting, by simply calling useGlobalSettings(). An alternate method would be to default individual key-bindings by usning setKeyBinding() with the default second argument.

In non-editable (select-only) mode only one completion mode, `CompletionAuto`, is available. All the other modes are simply ignored. Moreover, the CompletionAuto mode, unlike in the read-write mode, works by matching any typed key with the first letter of entries in the combobox.

Usage

To enable the basic completion feature:

     KComboBox *combo = new KComboBox( true, this, "mywidget" );
     KCompletion *comp = combo->completionObject();
     // Connect to the return pressed signal - optional
     connect(combo,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&));

     // Provide the to be completed strings. Note that those are separate from the combo's
     // contents.
     comp->insertItems( someQStringList );

To use your own completion object:

     KComboBox *combo = new KComboBox( this,"mywidget" );
     KURLCompletion *comp = new KURLCompletion();
     combo->setCompletionObject( comp );
     // Connect to the return pressed signal - optional
     connect(combo,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&));

Note that you have to either delete the allocated completion object when you don't need it anymore, or call setAutoDeleteCompletionObject( true );

Miscellaneous function calls:

     // Tell the widget not to handle completion and rotation
     combo->setHandleSignals( false );
     // Set your own completion key for manual completions.
     combo->setKeyBinding( KCompletionBase::TextCompletion, Qt::End );
     // Hide the context (popup) menu
     combo->setContextMenuEnabled( false );

Author:
  Dawit Alemayehu <adawit@kde.org>

Definition at line 121 of file kcombobox.h.

## Constructor & Destructor Documentation

KComboBox::KComboBox | ( | QWidget * | parent = 0,
|  | const char * | name = 0
| ) |

  | Constructs a read-only or rather select-only combo box with a parent object and a name. Parameters:
  parent | The parent object of this widget
  name | The name of this widget
Definition at line 60 of file kcombobox.cpp. References KStdAccel::name().

KComboBox::KComboBox | ( | bool | rw,
|  | QWidget * | parent = 0,
|  | const char * | name = 0
| ) |

  | Constructs a "read-write" or "read-only" combo box depending on the value of the first argument( `rw` ) with a parent, a name. Parameters:
  rw | When `true`, widget will be editable.
  parent | The parent object of this widget.
  name | The name of this widget.
Definition at line 66 of file kcombobox.cpp. References KStdAccel::name(), and QComboBox::setLineEdit().

KComboBox::~KComboBox | ( |  | ) | `[virtual]`

| Destructor. Definition at line 78 of file kcombobox.cpp.

## Member Function Documentation

void KComboBox::setEditURL | ( | const KURL & | url | ) |

| Sets `url` into the edit field of the combobox. It uses KURL::prettyURL() so that the url is properly decoded for displaying. Definition at line 207 of file kcombobox.cpp. References KURL::prettyURL(), and QComboBox::setEditText().

void KComboBox::insertURL | ( | const KURL & | url,
|  | int | index = -1
| ) |

| Inserts `url` at position `index` into the combobox. The item will be appended if `index` is negative. KURL::prettyURL() is used so that the url is properly decoded for displaying. Definition at line 212 of file kcombobox.cpp. References QComboBox::insertItem(), and KURL::prettyURL().

void KComboBox::insertURL | ( | const QPixmap & | pixmap,
|  | const KURL & | url,
|  | int | index = -1
| ) |

| Inserts `url` with the pixmap &p pixmap at position `index` into the combobox. The item will be appended if `index` is negative. KURL::prettyURL() is used so that the url is properly decoded for displaying. Definition at line 217 of file kcombobox.cpp. References QComboBox::insertItem(), and KURL::prettyURL().

void KComboBox::changeURL | ( | const KURL & | url,
|  | int | index
| ) |

| Replaces the item at position `index` with `url`. KURL::prettyURL() is used so that the url is properly decoded for displaying. Definition at line 222 of file kcombobox.cpp. References QComboBox::changeItem(), and KURL::prettyURL().

void KComboBox::changeURL | ( | const QPixmap & | pixmap,
|  | const KURL & | url,
|  | int | index
| ) |

| Replaces the item at position `index` with `url` and pixmap `pixmap`. KURL::prettyURL() is used so that the url is properly decoded for displaying. Definition at line 227 of file kcombobox.cpp. References QComboBox::changeItem(), and KURL::prettyURL().

int KComboBox::cursorPosition | ( |  | ) | const`[inline]`

| Returns the current cursor position. This method always returns a -1 if the combo-box is not editable (read-write). Returns: Current cursor position. Definition at line 199 of file kcombobox.h. References QComboBox::lineEdit().

void KComboBox::setAutoCompletion | ( | bool | autocomplete | ) | `[virtual]`

  | Re-implemented from QComboBox. If `true`, the completion mode will be set to automatic. Otherwise, it is defaulted to the global setting. This method has been replaced by the more comprehensive setCompletionMode(). Parameters:
  autocomplete | Flag to enable/disable automatic completion mode.
Reimplemented from QComboBox. Definition at line 117 of file kcombobox.cpp. References KGlobalSettings::CompletionAuto, KGlobalSettings::completionMode(), and KCompletionBase::setCompletionMode().

bool KComboBox::autoCompletion | ( |  | ) | const`[inline]`

| Re-implemented from QComboBox. Returns `true` if the current completion mode is set to automatic. See its more comprehensive replacement completionMode(). Returns: `true` when completion mode is automatic. Reimplemented from QComboBox. Definition at line 222 of file kcombobox.h. References KGlobalSettings::CompletionAuto, and KCompletionBase::completionMode().

void KComboBox::setContextMenuEnabled | ( | bool | showMenu | ) | `[virtual]`

  | Enables or disable the popup (context) menu. This method only works if this widget is editable, i.e. read-write and allows you to enable/disable the context menu. It does nothing if invoked for a none-editable combo-box. Note that by default the mode changer item is made visiable whenever the context menu is enabled. Use hideModechanger() if you want to hide this item. Also by default, the context menu is created if this widget is editable. Call this function with the argument set to false to disable the popup menu. Parameters:
  showMenu | If `true`, show the context menu.
  showMode | If `true`, show the mode changer.
Definition at line 134 of file kcombobox.cpp.

bool KComboBox::isContextMenuEnabled | ( |  | ) | const`[inline]`

| Returns `true` when the context menu is enabled. Definition at line 247 of file kcombobox.h.

void KComboBox::setURLDropsEnabled | ( | bool | enable | ) |

  | Enables/Disables handling of URL drops. If enabled and the user drops an URL, the decoded URL will be inserted. Otherwise the default behaviour of QComboBox is used, which inserts the encoded URL. Parameters:
  enable | If `true`, insert decoded URLs
Definition at line 141 of file kcombobox.cpp.

bool KComboBox::isURLDropsEnabled | ( |  | ) | const

| Returns `true` when decoded URL drops are enabled. Definition at line 147 of file kcombobox.cpp.

bool KComboBox::contains | ( | const QString & | text | ) | const

| Convenience method which iterates over all items and checks if any of them is equal to `text`. If `text` is an empty string, `false` is returned. Returns: `true` if an item with the string `text` is in the combobox. Definition at line 104 of file kcombobox.cpp. References QComboBox::count(), QString::isEmpty(), and QComboBox::text(). Referenced by KHistoryCombo::addToHistory().

void KComboBox::setTrapReturnKey | ( | bool | trap | ) |

| By default, KComboBox recognizes Key_Return and Key_Enter and emits the returnPressed() signals, but it also lets the event pass, for example causing a dialog's default-button to be called. Call this method with `trap` equal to true to make KComboBox stop these events. The signals will still be emitted of course. Only affects read-writable comboboxes. See also: setTrapReturnKey() Definition at line 193 of file kcombobox.cpp.

bool KComboBox::trapReturnKey | ( |  | ) | const

| Returns: `true` if keyevents of Key_Return or Key_Enter will be stopped or if they will be propagated. See also: setTrapReturnKey () Definition at line 201 of file kcombobox.cpp.

bool KComboBox::eventFilter | ( | QObject * | ,
|  | QEvent * |
| ) | `[virtual]`

| Re-implemented for internal reasons. API not affected. Definition at line 188 of file kcombobox.cpp.

KCompletionBox * KComboBox::completionBox | ( | bool | create = true | ) |

  | Returns: the completion-box, that is used in completion mode KGlobalSettings::CompletionPopup and KGlobalSettings::CompletionPopupAuto. This method will create a completion-box by calling KLineEdit::completionBox, if none is there, yet. Parameters:
  create | Set this to false if you don't want the box to be created i.e. to test if it is available.
Definition at line 238 of file kcombobox.cpp. References KStdAction::create().

void KComboBox::returnPressed | ( |  | ) | `[signal]`

| Emitted when the user presses the Enter key. Note that this signal is only emitted if this widget is editable.

void KComboBox::returnPressed | ( | const QString & |  | ) | `[signal]`

| Emitted when the user presses the Enter key. The argument is the current text being edited. This signal is just like returnPressed() except it contains the current text as its argument. Note that this signal is only emitted if this widget is editable.

void KComboBox::completion | ( | const QString & |  | ) | `[signal]`

| This signal is emitted when the completion key is pressed. The argument is the current text being edited. Note that this signal is not available if this widget is non-editable or the completion mode is set to `KGlobalSettings::CompletionNone`.

void KComboBox::substringCompletion | ( | const QString & |  | ) | `[signal]`

| Emitted when the shortcut for substring completion is pressed.

void KComboBox::textRotation | ( | KCompletionBase::KeyBindingType |  | ) | `[signal]`

| Emitted when the text rotation key-bindings are pressed. The argument indicates which key-binding was pressed. In this case this can be either one of four values: `PrevCompletionMatch`, `NextCompletionMatch`, `RotateUp` or `RotateDown`. See KCompletionBase::setKeyBinding() for details. Note that this signal is NOT emitted if the completion mode is set to CompletionNone.

void KComboBox::completionModeChanged | ( | KGlobalSettings::Completion |  | ) | `[signal]`

| Emitted when the user changed the completion mode by using the popupmenu.

void KComboBox::aboutToShowContextMenu | ( | QPopupMenu * |  | ) | `[signal]`

  | Emitted before the context menu is displayed. The signal allows you to add your own entries into the the context menu that is created on demand. NOTE: Do not store the pointer to the QPopupMenu provided through since it is created and deleted on demand. Parameters:
  the | context menu about to be displayed

void KComboBox::rotateText | ( | KCompletionBase::KeyBindingType |  | ) | `[slot]`

  | Iterates through all possible matches of the completed text or the history list. Depending on the value of the argument, this function either iterates through the history list of this widget or the all possible matches in whenever multiple matches result from a text completion request. Note that the all-possible-match iteration will not work if there are no previous matches, i.e. no text has been completed and the *nix shell history list rotation is only available if the insertion policy for this widget is set either `QComobBox::AtTop` or `QComboBox::AtBottom`. For other insertion modes whatever has been typed by the user when the rotation event was initiated will be lost. Parameters:
  type | The key-binding invoked.
Definition at line 181 of file kcombobox.cpp.

void KComboBox::setCompletedText | ( | const QString & |  | ) | `[virtual, slot]`

| Sets the completed text in the line-edit appropriately. This function is an implementation for KCompletionBase::setCompletedText. Implements KCompletionBase. Definition at line 159 of file kcombobox.cpp.

void KComboBox::setCompletedItems | ( | const QStringList & | items | ) | `[virtual, slot]`

| Sets `items` into the completion-box if completionMode() is CompletionPopup. The popup will be shown immediately. Implements KCompletionBase. Definition at line 232 of file kcombobox.cpp.

void KComboBox::setCurrentItem | ( | const QString & | item,
|  | bool | insert = false,
|  | int | index = -1
| ) | `[slot]`

| Selects the first item that matches `item`. If there is no such item, it is inserted at position `index` if `insert` is true. Otherwise, no item is selected. Definition at line 315 of file kcombobox.cpp. References QComboBox::count(), KStdAccel::insert(), QComboBox::insertItem(), and QComboBox::text(). Referenced by KHistoryCombo::addToHistory(), makeCompletion(), and KFontCombo::setCurrentFont().

virtual void KComboBox::itemSelected | ( | QListBoxItem * |  | ) | `[inline, protected, virtual, slot]`

| This class or method is obsolete, it is provided for compatibility only.. Definition at line 441 of file kcombobox.h.

void KComboBox::makeCompletion | ( | const QString & |  | ) | `[protected, virtual, slot]`

| Completes text according to the completion mode. Note: this method is `not` invoked if the completion mode is set to CompletionNone. Also if the mode is set to `CompletionShell` and multiple matches are found, this method will complete the text to the first match with a beep to inidicate that there are more matches. Then any successive completion key event iterates through the remaining matches. This way the rotation functionality is left to iterate through the list as usual. Definition at line 165 of file kcombobox.cpp. References QString::isNull(), QComboBox::listBox(), and setCurrentItem().

void KComboBox::create | ( | WId | = 0,
|  | bool | initializeWindow = true,
|  | bool | destroyOldWindow = true
| ) | `[protected, virtual]`

| Reimplemented for internal reasons, the API is not affected. Definition at line 246 of file kcombobox.cpp. References QComboBox::lineEdit(), and KCursor::setAutoHideCursor().

The documentation for this class was generated from the following files:

- kcombobox.h
- kcombobox.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 12:59:18 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001